function [J_max, M_min, M_length] = WA_frequencyPartition(n, partition)
    if(partition == 1)
        [J_max, M_min, M_length] = WA_OrthogonalFrequencyPartition(n);
    elseif(partition == 2)
        [J_max, M_min, M_length] = WA_UniformFrequencyPartition(n);
    else
        error('Parition is not 0 (multiscale) or 1 (monoscale)')
    end        
end

function [J_max, M_start, M_length] = WA_UniformFrequencyPartition(n)
    if(n < 8)
        error(['The number of elements in the smallest dimension must be '...
               'at least 8 in monoscale! '...
                   'Currently it is ', num2str(n)])
    end
    
    J_max = floor(log2(n)/2);    
    M_start = zeros(J_max+1,1);
    M_length = zeros(J_max+1,1);
    
    M_length(J_max+1) = n/2^(J_max+1);

end

function [J_max, M_start, M_length] = WA_OrthogonalFrequencyPartition(n)
    if(n < 4)
        error(['The number of elements in the smallest dimension must be '...
               'at least 4 in multicase! '...
                   'Currently it is ', num2str(n)])
    end
    
    if(n == 4)
        J_max = 0;
        M_length = [2];
        M_start = [0];
    elseif(n == 8)
        J_max = 1;
        M_length = [2,2];
        M_start = [0,1];        
    elseif(n == 16)
        J_max = 1;
        M_length = [2,4];
        M_start = [0,1];
    elseif(n == 32)
        J_max = 2;
        M_length = [2,6,4];
        M_start = [0,1,3];        
    elseif(n == 64)
        J_max = 2;
        M_length = [2,6,8];
        M_start = [0,1,3];                
    else
        %These can probably be calculated easier than done here now.
        r = 4; f = 7; s = 80;
        J_max = 2;
        while(s<n)
            f = 2*f-1;
            s = s+4*r*f;
            J_max = J_max+1;
            r = 2*r;
        end
        
        M_length = [2,6,10];
        M_start = [0,1,3];
        
        r = 4; f = 7; s = 80; olds = 80;
        for jj = 3:J_max
            f = 2*f-1;
            s = s+4*r*f;        

            M_start(jj+1) = 2^(jj-1)+1;
            if(s<=n)
                M_length(jj+1) = f+M_start(jj+1);
            else
                M_length(jj+1) = (n-olds)/(4*r)+M_start(jj+1);
            end   

            r = 2*r;
            olds = s;
        end
        
    end

end

