#include "WA_cmdparser.h"

int getCharCmdArg(int argc, char**argv, char *cmdFlag, char **cmdArg)
{
  if (argv == NULL || cmdFlag == NULL){
    return 0;
  }

  int i = cmdArgSpecified(argc,argv,cmdFlag);
  if (i > 0){
    *cmdArg = argv[i];
    return 1;
  } 

  *cmdArg = NULL;
  return 0;
} 

int getIntCmdArg(int argc, char**argv, char *cmdFlag, int *cmdArg)
{
  if (argv == NULL || cmdFlag == NULL){
    return 0;
  }

  int i = cmdArgSpecified(argc,argv,cmdFlag);
  if (i > 0){
    *cmdArg = atoi(argv[i]);
    return 1;
  } 

  *cmdArg = 0;
  return 0;
} 

int getDoubleCmdArg(int argc, char**argv, char *cmdFlag, double *cmdArg)
{
  if (argv == NULL || cmdFlag == NULL){
    return 0;
  }

  int i = cmdArgSpecified(argc,argv,cmdFlag);
  if (i > 0){
    *cmdArg = atof(argv[i]);
    return 1;
  } 

  *cmdArg = 0;
  return 0;
} 


int cmdArgSpecified(int argc, char **argv, char *cmdFlag)
{
  if (argv == NULL || cmdFlag == NULL){
    return -1;
  }

  for(int i = 0; i<argc-1; ++i){
    if (argv[i][0] == '-'){
      if (strcmp(&argv[i][1],cmdFlag)==0){
	return i+1;
      }
      ++i;
    }
  }
  return -1; 
}

