#ifndef WA_CMDPARSER_H_INCLUDED
#define WA_CMDPARSER_H_INCLUDED

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
  Read string specified by a flag from command line parameters.
  Returns nonzero on success, zero otherwise.
 */
int getCharCmdArg(int argc, char**argv, char *cmdFlag, char **cmdArg);

/*
  Read int specified by a flag from command line parameters.
  Returns nonzero on success, zero otherwise.
 */
int getIntCmdArg(int argc, char**argv, char *cmdFlag, int *cmdArg);

/*
  Read double specified by a flag from command line parameters.
  Returns nonzero on success, zero otherwise.
 */
int getDoubleCmdArg(int argc, char**argv, char *cmdFlag, double *cmdArg);

/*
  Check whether a given command line flag is specified.
  Returns position of flag in argv on success, -1 otherwise.
 */
int cmdArgSpecified(int argc, char **argv, char *cmdFlag);

#endif
