#ifndef WA_DATATYPES_H_INCLUDED
#define WA_DATATYPES_H_INCLUDED

#include <complex.h>

typedef struct {
  size_t numberOfDimensions; //Number of dimensions
  size_t numberOfElements;   //Total number of elements
  size_t *sizeOfDimension;   //Number of elements in each dimension
  double complex *data;      //Actual data values
} inputData;

typedef struct {
  size_t maxJ;       //Maximum scale j
  size_t *lengthOfM; //Maximum valid value for m
  size_t *startOfM;  //Start of valid m values
} frequencyPartition;

#endif
