#ifndef WA_FWA_H_INCLUDED
#define WA_FWA_H_INCLUDED

#include <stdbool.h>
#include <string.h>
#include <complex.h>
#include <fftw3.h>
#include "WA_constants.h"
#include "WA_frequencypartition.h"

/*
  These functions calculate forward Wave Atom transform.
  id contains input data
  coefficients is a pointer where calculated coefficients are stored
  uniformpartition indicates whether to use multiscale or monoscale.
  fftw_flags is passed to FFTW planner
  returns true on success and false otherwise. On success, coefficients contains calculated coefficients.
 */


bool fwa1(const inputData *id, double complex** coefficients, bool uniformpartition, unsigned fftw_flags);

bool fwa2(const inputData *id, double complex** coefficients, bool uniformpartition, unsigned fftw_flags);

bool fwa3(const inputData *id, double complex** coefficients, bool uniformpartition, unsigned fftw_flags);

bool fwa4(const inputData *id, double complex** coefficients, bool uniformpartition, unsigned fftw_flags);

bool fwa5(const inputData *id, double complex** coefficients, bool uniformpartition, unsigned fftw_flags);

#endif
