#ifndef WA_IWA_H_INCLUDED
#define WA_IWA_H_INCLUDED

#include <stdbool.h>
#include <string.h>
#include <complex.h>
#include <fftw3.h>
#include "WA_constants.h"
#include "WA_frequencypartition.h"

/*
  These functions calculate inverse Wave Atom transform.
  id is a pointer to inputData where calculated inverse will be stored
  coefficients is a pointer to input coefficients
  uniformpartition indicates whether to use multiscale or monoscale
  fftw_flags is passed to FFTW planner
  returns true on success and false otherwise. On success, id contains calculated inverse.
 */

bool iwa1(inputData *id, double complex* coefficients, bool uniformpartition,unsigned fftw_flags);

bool iwa2(inputData *id, double complex* coefficients, bool uniformpartition,unsigned fftw_flags);

bool iwa3(inputData *id, double complex* coefficients, bool uniformpartition,unsigned fftw_flags);

bool iwa4(inputData *id, double complex* coefficients, bool uniformpartition,unsigned fftw_flags);

bool iwa5(inputData *id, double complex* coefficients, bool uniformpartition,unsigned fftw_flags);

#endif
