#ifndef WA_CUDA_KERNELS_INCLUDED
#define WA_CUDA_KERNELS_INCLUDED

/*
  CUDA kernels used in 2D and 3D forward and inverse Wave Atom transfers.
 */

__global__ void kernel2D_gpu(int i1, int i2,	      
			     int sm, int lm, 
			     int mstart, int actuallyCalcBlocksAlready,
			     int dime1, int dime2,
			     int rnc1, int rnc2,
			     int nelemsj, 
			     cuDoubleComplex *data,
			     cuDoubleComplex *tempmemory,
			     cuDoubleComplex *dataws1, 
			     cuDoubleComplex *dataws2,
			     int *wacoefStart
			     );

__global__ void inverse_kernel2D_gpu(int i1, int i2,	      
				     int p1, int p2,
				     int sm, int lm, 
				     int mstart, 
				     int actuallyCalcBlocksAlready,
				     int dime1, int dime2,
				     int rnc1, int rnc2,
				     int nelemsj, 
				     cuDoubleComplex *data,
				     cuDoubleComplex *tempmemory,
				     cuDoubleComplex *dataws1, 
				     cuDoubleComplex *dataws2,
				     int *wacoefStart
				     );


__global__ void kernel3D_gpu(int i1, int i2, int i3,
			     int sm, int lm, 
			     int mstart, int actuallyCalcBlocksAlready,
			     int dime1, int dime2, int dime3,
			     int rnc1, int rnc2, int rnc3,
			     int nelemsj, 
			     cuDoubleComplex *data,
			     cuDoubleComplex *tempmemory,
			     cuDoubleComplex *dataws1, 
			     cuDoubleComplex *dataws2,
			     cuDoubleComplex *dataws3,
			     int *wacoefStart
			     );

__global__ void inverse_kernel3D_gpu(int i1, int i2, int i3,
				     int p1, int p2, int p3,
				     int sm, int lm, 
				     int mstart, int actuallyCalcBlocksAlready,
				     int dime1, int dime2, int dime3,
				     int rnc1, int rnc2, int rnc3,
				     int nelemsj, 
				     cuDoubleComplex *data,
				     cuDoubleComplex *tempmemory,
				     cuDoubleComplex *dataws1, 
				     cuDoubleComplex *dataws2,
				     cuDoubleComplex *dataws3,
				     int *wacoefStart
				     );



#endif
