#ifndef WA_FWA_H_INCLUDED
#define WA_FWA_H_INCLUDED

#include <stdbool.h>
#include <complex.h>
#include <string.h>

#include "WA_cuda.h"
#include "WA_constants.h"
#include "WA_frequencypartition.h"

/*
  These functions calculate forward Wave Atom transform.
  id contains input data
  coefficients is a pointer where calculated coefficients are stored
  uniformpartition indicates whether to use multiscale or monoscale
  d_inputdata containts input data moved to device
  returns true on success and false otherwise. On success, coefficients contains calculated coefficients.
 */


bool fwa2(const inputData *id, double complex** coefficients, bool uniformpartition, cuDoubleComplex *d_inputdata);

bool fwa3(const inputData *id, double complex** coefficients, bool uniformpartition, cuDoubleComplex *d_inputdata);

#endif
