#ifndef WA_IWA_H_INCLUDED
#define WA_IWA_H_INCLUDED

#include <stdbool.h>
#include <complex.h>
#include <string.h>

#include "WA_cuda.h"
#include "WA_constants.h"
#include "WA_frequencypartition.h"

/*
  These functions calculate inverse Wave Atom transform.
  id is a pointer to inputData where calculated inverse will be stored
  coefficients is a pointer to input coefficients
  uniformpartition indicates whether to use multiscale or monoscale
  returns true on success and false otherwise. On success, id contains calculated inverse.
 */

bool iwa2(const inputData *id, double complex* coefficients, bool uniformpartition);
bool iwa3(const inputData *id, double complex* coefficients, bool uniformpartition);

#endif
